SystemOrganization addCategory: #'tODE-Search'!

TOView subclass: #TOSearch
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Search'!

!TOSearch methodsFor: 'searching' stamp: 'dkh 7/6/2011 18:16'!
doSearch: pragmas main: main
	| searchResults noSearch |
	searchResults := OrderedCollection new.
	noSearch := true.
	pragmas
		do: [ :pragma | 
			(self properties at: (pragma argumentAt: 2))
				ifTrue: [noSearch := false ] ].
	noSearch
		ifTrue: [  self properties at: #classSearch put: true ].
	pragmas
		do: [ :pragma | 
			(self properties at: (pragma argumentAt: 2))
				ifTrue: [ searchResults := searchResults , (self perform: pragma selector) ] ].
	self
		pushit: (self searchResults: searchResults labeled: 'Search for ' , searchText printString)
		selecting: #view
		main: main! !

!TOSearch methodsFor: 'printing' stamp: 'dkh 6/15/2011 12:14'!
printOn: aStream

	super printOn: aStream.
	searchText ifNil: [ ^self ].
	aStream 
		nextPut: $(;
		nextPutAll: searchText;
		nextPut: $)! !

!TOSearch methodsFor: 'rendering' stamp: 'dkh 6/21/2011 11:15'!
renderViewContentOn: html spec: aTOTabSpec main: main
	| id pragmas cid |
	self frame: aTOTabSpec frame.
	pragmas := (Pragma allNamed: #todeSearch:selector:priority: in: self class)
		sorted: [ :a :b | (a argumentAt: 3) <= (b argumentAt: 3) ].
	pragmas
		do: [ :pragma | self properties at: (pragma argumentAt: 2) ifAbsent: [ self properties at: (pragma argumentAt: 2) put: false ] ].
	(html textInput)
		id: (id := html nextId);
		exampleText: 'search term';
		value: searchText;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchText := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: pragmas main: main.
									main updateCenterSideHistory: s.	"clear the input field"
									s << ((html jQuery id: id) value: '') ]).
	pragmas
		do: [ :pragma | 
			| label selector |
			label := pragma argumentAt: 1.
			selector := pragma argumentAt: 2.
			html break.
			(html checkbox)
				id: (cid := html nextId);
				value: (self properties at: selector);
				onChange:
						((html jQuery ajax)
								callback: [ :value | self properties at: selector put: (self properties at: selector) not ]
									value: (html jQuery id: cid) value;
								script: [ :s | s << ((html jQuery id: cid) value: (self properties at: selector)) ]).
			(html label)
				for: cid;
				with: label ].
	html break.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchText := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: pragmas main: main.
									main updateCenterSideHistory: s.	"clear the input field"
									s << ((html jQuery id: id) value: '') ]);
		with: 'Search'! !

!TOSearch methodsFor: 'accessing' stamp: 'dkh 6/20/2011 03:08'!
searchText: aString
	searchText := aString! !

!TOSearch methodsFor: 'searching' stamp: 'dkh 6/13/2011 08:02'!
stringQueryResults
	<todeSearch: 'String' selector: #stringSearch priority: 29>
	^(self currentSystem allMethodsWithSourceString: searchText matchCase: false) sorted: [:a :b | a selector <= b selector ]! !
